#
# RecurringEvent/Extensions/Install.py
#


import os

from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs
from App.Common import package_home

from Products import RecurringEvent
from Products.RecurringEvent.config import *

# not used yet
# from Products.RecurringEvent.Extensions.utils import *

def install(self):
    """Install RecurringEvent: Install content types, skin layer, install the
    stylesheet, set up global properties, enable the portal factory and
    set up form controller actions for the widget actions
    """

    out = StringIO()

    print >> out, "Installing RecurringEvent"

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # Install skin
    install_subskin(self, out, product_globals)
    print >> out, "Installed skin"
    
    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'RecurringEvent' not in types:
        types.append('RecurringEvent')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

    print >> out, "Added RecurringEvent to portal_factory"

    propsTool = getToolByName(self, 'portal_properties')
    siteProperties = getattr(propsTool, 'site_properties')
    navtreeProperties = getattr(propsTool, 'navtree_properties')

    # add to siteProperties a property where default e-mail for administrator would be setuped
    #
    # to be realized in future ;)

 

    #
    # creation of recurring_event_workflow
    #   
    from Products.RecurringEvent.Extensions.recurring_event_workflow import create_recurring_event_workflow,setup_recurring_event_workflow
    wfid='recurring_event_workflow'
    wf=create_recurring_event_workflow(wfid)
    
    wft=self.portal_workflow
    wft._setObject(wfid,wf)
    wft.setChainForPortalTypes(['RecurringEvent'], wf.getId())

    print >>out, 'set up workflow recurring_event_workflow'

    #
    # import Scheduler object from zexp file
    #
    fpath=os.path.join(package_home(RecurringEvent.__dict__), 'scheduler.zexp')
    self._importObjectFromFile(fpath)

    print >>out, 'scheduler.zexp imported'
    
    #
    # setup 'Subject' Policy via portal_metada for RecurringEvent
    #
    self.portal_metadata.updateElementPolicy(
        element='Subject',
        content_type='RecurringEvent',
        is_required=0,
        supply_default=0,
        default_value='',
        enforce_vocabulary=0,
        allowed_vocabulary=('Appointment', 'Convention', 
            'Meeting', 'Special Event', 'Work'),
        REQUEST=None,
        )

    print >>out, 'Subject policy created'
    
    return out.getvalue()